# All files / src/options OptionsNormalizer.ts

100% Statements 49/49
100% Branches 20/20
100% Functions 0/0
100% Lines 44/44

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1835x

    14680x
    14680x

    1835x

    1835x
    1096x

    1835x

    1835x
    3x

    5x
    5x

    3x

    1835x

    1835x
    3x

    1835x

    1835x

    1835x
    1824x

    1824x

    11x
    4x

    11x

    1835x

    1835x
    11x

    11x

    1835x

    1835x
    1282x

    1835x

    1835x
    1x

    1835x

    1835x
    1283x

    1835x

     import { TInputOptions } from '../types/options/TInputOptions';

    import { IOptions } from '../interfaces/options/IOptions';

    import { TOptionsNormalizerRule } from '../types/options/TOptionsNormalizerRule';

    import { Utils } from '../utils/Utils';

    export class OptionsNormalizer {
        /**
         * @type {TInputOptions}
         */
        private static readonly DISABLED_CONTROL_FLOW_FLATTENING_OPTIONS: TInputOptions = {
            controlFlowFlattening: false,
            controlFlowFlatteningThreshold: 0
        };

        /**
         * @type {TInputOptions}
         */
        private static readonly DISABLED_STRING_ARRAY_OPTIONS: TInputOptions = {
            rotateStringArray: false,
            stringArray: false,
            stringArrayEncoding: false,
            stringArrayThreshold: 0
        };

        /**
         * @type {TInputOptions}
         */
        private static readonly SELF_DEFENDING_OPTIONS: TInputOptions = {
            compact: true,
            selfDefending: true
        };

        /**
         * @type {TInputOptions}
         */
        private static readonly STRING_ARRAY_ENCODING_OPTIONS: TInputOptions = {
            stringArrayEncoding: 'base64'
        };

        /**
         * @type {TOptionsNormalizerRule[]}
         */
        private static readonly normalizerRules: TOptionsNormalizerRule[] = [
            OptionsNormalizer.controlFlowFlatteningThresholdRule,
            OptionsNormalizer.domainLockRule,
            OptionsNormalizer.selfDefendingRule,
            OptionsNormalizer.sourceMapBaseUrlRule,
            OptionsNormalizer.sourceMapFileNameRule,
            OptionsNormalizer.stringArrayRule,
            OptionsNormalizer.stringArrayEncodingRule,
            OptionsNormalizer.stringArrayThresholdRule,
        ];

        /**
         * @param options
         * @returns {IOptions}
         */
        public static normalizeOptions (options: IOptions): IOptions {
            let normalizedOptions: IOptions = {
                ...options
            };

            for (const normalizerRule of OptionsNormalizer.normalizerRules) {
                normalizedOptions = normalizerRule(normalizedOptions);
            }

            return normalizedOptions;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static controlFlowFlatteningThresholdRule (options: IOptions): IOptions {
            if (options.controlFlowFlatteningThreshold === 0) {
                options = {
                    ...options,
                    ...OptionsNormalizer.DISABLED_CONTROL_FLOW_FLATTENING_OPTIONS
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static domainLockRule (options: IOptions): IOptions {
            if (options.domainLock.length) {
                const normalizedDomains: string[] = [];

                for (const domain of options.domainLock) {
                    normalizedDomains.push(Utils.extractDomainFromUrl(domain));
                }

                options = {
                    ...options,
                    domainLock: normalizedDomains
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static selfDefendingRule (options: IOptions): IOptions {
            if (options.selfDefending) {
                options = {
                    ...options,
                    ...OptionsNormalizer.SELF_DEFENDING_OPTIONS
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static sourceMapBaseUrlRule (options: IOptions): IOptions {
            const { sourceMapBaseUrl }: { sourceMapBaseUrl: string } = options;

            if (!options.sourceMapFileName) {
                options = {
                    ...options,
                    sourceMapBaseUrl: ''
                };

                return options;
            }

            if (sourceMapBaseUrl && !sourceMapBaseUrl.endsWith('/')) {
                options = {
                    ...options,
                    sourceMapBaseUrl: `${sourceMapBaseUrl}/`
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static sourceMapFileNameRule (options: IOptions): IOptions {
            let { sourceMapFileName }: { sourceMapFileName: string } = options;

            if (sourceMapFileName) {
                sourceMapFileName = sourceMapFileName
                    .replace(/^\/+/, '')
                    .split('.')[0];

                options = {
                    ...options,
                    sourceMapFileName: `${sourceMapFileName}.js.map`
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static stringArrayRule (options: IOptions): IOptions {
            if (!options.stringArray) {
                options = {
                    ...options,
                    ...OptionsNormalizer.DISABLED_STRING_ARRAY_OPTIONS
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static stringArrayEncodingRule (options: IOptions): IOptions {
            if (options.stringArrayEncoding === true) {
                options = {
                    ...options,
                    ...OptionsNormalizer.STRING_ARRAY_ENCODING_OPTIONS
                };
            }

            return options;
        }

        /**
         * @param options
         * @returns {IOptions}
         */
        private static stringArrayThresholdRule (options: IOptions): IOptions {
            if (options.stringArrayThreshold === 0) {
                options = {
                    ...options,
                    ...OptionsNormalizer.DISABLED_STRING_ARRAY_OPTIONS
                };
            }

            return options;
        }
    }